
/**
 * mod_dmenu
 *
 * @version 1.0
 * @author Creative Pulse
 * @copyright Creative Pulse 2011
 * @license http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 * @link http://www.creativepulse.eu
 */


function Mod_DMenu_Card(iname) {
	this.base_iname = iname;
	this.wdg = document.createElement("div");
	document.getElementsByTagName("body")[0].appendChild(this.wdg);
}

Mod_DMenu_Card.prototype.setup_wdg = function () {
	this.wdg.setAttribute("iname", this.base_iname)
	this.wdg.onmouseover = function () { document.mod_dmenu_inst[this.getAttribute("iname")].h_mouseover(this.getAttribute("hd_id")); }
	this.wdg.onmouseout = function () { document.mod_dmenu_inst[this.getAttribute("iname")].h_mouseout(this.getAttribute("hd_id")); }

	this.wdg.style.visibility = "hidden";
	this.wdg.style.position = "absolute";
	this.wdg.style.left = "0px";
	this.wdg.style.top = "0px";
	this.wdg.style.display = "block";
	this.wdg_w = this.wdg.offsetWidth;
	this.wdg.style.display = "none";
	this.wdg.style.visibility = "visible";
	this.wdg.style.position = "static";

	var node = this.wdg.firstChild;
	while (node) {
		if (node.nodeType == 1 && node.tagName == "TABLE" && node.offsetWidth < this.wdg_w) {
			node.style.width = this.wdg_w + "px";
		}
		node = node.nextSibling;
	}
}

function Mod_DMenu_Deck(base, hd_id, hd_wdg, main_card) {
	this.base = base;
	this.hd_id = hd_id;
	this.hd_wdg = hd_wdg;
	this.main_card = main_card;
	this.card_queue = [];
	this.progress = 0;
	this.start_x = 0;
	this.start_y = 0;

	this.state = 0;
	this.ST_HIDDEN = 0;
	this.ST_OPEN = 1;
	this.ST_OPENING = 2;
	this.ST_CLOSING = 3;
	this.ST_SLIDE_PREVIOUS = 4;
	this.ST_SLIDE_NEXT = 5;
	this.ST_FITTING = 6;
}

Mod_DMenu_Deck.prototype.h_mouseover = function () {
	if (this.state == this.ST_CLOSING) {
		this.base.stop_ani_timer();
		this.state = this.ST_OPEN;
		
		if (this.base.animation) {
			this.base.deck_wdg.style.opacity = 1;
			this.base.deck_wdg.style.filter = "alpha(opacity=100)";
		}
	}
}

Mod_DMenu_Deck.prototype.open_main = function () {
	this.start_x = Math.round(this.hd_wdg.offsetWidth / 2);
	this.start_y = this.hd_wdg.offsetHeight;
	var obj = this.hd_wdg;
	while (obj) {
		this.start_x += obj.offsetLeft;
		this.start_y += obj.offsetTop;
		obj = obj.offsetParent;
	}

	this.base.deck_wdg.style.left = this.start_x + "px";
	this.base.deck_wdg.style.top = this.start_y + "px";
	this.base.deck_wdg.style.display = "block";

	if (this.base.animation) {
		this.base.deck_wdg.style.opacity = 1;
		this.base.deck_wdg.style.filter = "alpha(opacity=100)";

		this.base.show_container_wdg.style.width = "0px";
		this.base.show_container_wdg.style.height = "0px";
	
		this.base.show_slides_wdg_x = 0;
		this.base.show_slides_wdg.style.left = this.base.show_slides_wdg_x + "px";
	}
	
	while (this.base.show_area_wdg.firstChild) {
		this.base.stock_wdg.appendChild(this.base.show_area_wdg.firstChild);
	}

	this.main_card.wdg.style.display = "block";
	this.base.show_area_wdg.appendChild(this.main_card.wdg);
	this.card_queue.push(this.main_card);
	
	this.main_card.wdg.setAttribute("hd_id", this.hd_id);

	this.base.rsz(false);

	this.state = this.ST_OPENING;
	this.progress = 0;
	this.base.start_ani_timer(this.base.ani_open_interval);
}

Mod_DMenu_Deck.prototype.open_card = function (card) {
	card.wdg.setAttribute("hd_id", this.hd_id);
	this.base.show_new_wdg.appendChild(card.wdg);
	card.wdg.style.display = "block";
	
	this.base.rsz(false);
	
	this.card_queue.push(card);
	this.state = this.ST_SLIDE_NEXT;
	this.base.start_ani_timer(this.base.ani_slide_interval);
}

Mod_DMenu_Deck.prototype.back_card = function () {
	if (this.card_queue.length > 1) {
		this.base.show_new_wdg.appendChild(this.base.show_area_wdg.firstChild);
		this.base.show_area_wdg.appendChild(this.card_queue[this.card_queue.length - 2].wdg);
		
		if (this.base.animation) {
			this.base.show_slides_wdg_x = -this.base.show_area_wdg.offsetWidth;
			this.base.show_slides_wdg.style.left = this.base.show_slides_wdg_x + "px";
		}
		
		this.state = this.ST_SLIDE_PREVIOUS;
		this.base.start_ani_timer(this.base.ani_slide_interval);
	}
}

Mod_DMenu_Deck.prototype.start_close_timer = function () {
	this.state = this.ST_CLOSING;
	this.progress = 100;
	this.base.start_ani_timer(this.base.ani_close_interval);
}

Mod_DMenu_Deck.prototype.h_ani_timer = function () {
	var interval = 20;
	
	if (this.state == this.ST_OPENING) {
		interval = this.base.ani_open_interval;
		
		this.progress += this.base.ani_open_speed;
		if (this.progress >= 100 || !this.base.animation) {
			this.progress = 100;
			this.state = this.ST_OPEN;
		}
		
		var card = this.card_queue[this.card_queue.length - 1];

		this.base.show_container_wdg.style.width = Math.round(this.base.show_area_wdg.offsetWidth * this.progress / 100) + "px";
		this.base.show_container_wdg.style.height = Math.round(this.base.show_area_wdg.offsetHeight * this.progress / 100) + "px";
		
		this.base.deck_wdg.style.left = (this.start_x - Math.round(this.base.deck_wdg.offsetWidth / 2)) + "px";
		
		if (this.base.animation) {
			this.base.show_container_wdg.style.opacity = this.progress / 100;
			this.base.show_container_wdg.style.filter = "alpha(opacity=" + Math.round(this.progress) + ")";
		}
		
		this.base.rsz(true);
	}
	else if (this.state == this.ST_CLOSING) {
		interval = this.base.ani_close_interval;

		this.progress -= this.base.ani_close_speed;
		if (this.progress <= 0 || !this.base.animation) {
			this.progress = 0;
			this.state = this.ST_HIDDEN;
			this.base.deck_wdg.style.display = "none";
			this.base.disable_deck(this.hd_id);
		}

		if (this.base.animation) {
			this.base.deck_wdg.style.opacity = this.progress / 100;
			this.base.deck_wdg.style.filter = "alpha(opacity=" + Math.round(this.progress) + ")";
		}
	}
	else if (this.state == this.ST_SLIDE_PREVIOUS) {
		interval = this.base.ani_slide_interval;

		var diff = Math.round(-this.base.show_slides_wdg_x * this.base.ani_slide_speed / 100);
		if (diff < 1) {
			diff = 1;
		}
		var val = this.base.show_slides_wdg_x + diff;

		if (val >= 0 || !this.base.animation) {
			this.progress = 0;
			this.state = this.ST_FITTING;
			
			this.card_queue.pop();
			
			while (this.base.show_new_wdg.firstChild) {
				this.base.stock_wdg.appendChild(this.base.show_new_wdg.firstChild);
			}

			if (this.base.animation) {
				this.base.show_slides_wdg_x = 0;
				this.base.show_slides_wdg.style.left = this.base.show_slides_wdg_x + "px";
			}
		}
		else {
			this.base.show_slides_wdg_x = val;
			this.base.show_slides_wdg.style.left = this.base.show_slides_wdg_x + "px";
		}
	}
	else if (this.state == this.ST_SLIDE_NEXT) {
		interval = this.base.ani_slide_interval;

		var diff = Math.round((this.base.show_area_wdg.offsetWidth + this.base.show_slides_wdg_x) * this.base.ani_slide_speed / 100);
		if (diff < 1) {
			diff = 1;
		}
		var val = this.base.show_slides_wdg_x - diff;

		if (-val >= this.base.show_area_wdg.offsetWidth || !this.base.animation) {
			this.progress = 0;
			this.state = this.ST_FITTING;
			
			while (this.base.show_area_wdg.firstChild) {
				this.base.stock_wdg.appendChild(this.base.show_area_wdg.firstChild);
			}

			this.base.show_area_wdg.appendChild(this.base.show_new_wdg.firstChild);

			if (this.base.animation) {
				this.base.show_slides_wdg_x = 0;
				this.base.show_slides_wdg.style.left = this.base.show_slides_wdg_x + "px";
			}
		}
		else {
			this.base.show_slides_wdg_x = val;
			this.base.show_slides_wdg.style.left = this.base.show_slides_wdg_x + "px";
		}
	}
	else if (this.state == this.ST_FITTING) {
		if (!this.base.animation || (this.base.show_area_wdg.offsetWidth == this.base.show_container_wdg.offsetWidth && this.base.show_area_wdg.offsetHeight == this.base.show_container_wdg.offsetHeight)) {
			this.state = this.ST_OPEN;
			
			if (!this.base.animation) {
				this.base.show_container_wdg.style.width = this.base.show_area_wdg.offsetWidth + "px";
				this.base.show_container_wdg.style.height = this.base.show_area_wdg.offsetHeight + "px";
				this.base.deck_wdg.style.left = (this.start_x - Math.round(this.base.deck_wdg.offsetWidth / 2)) + "px";

				this.base.rsz(true);
			}
		}
		else {
			interval = this.base.ani_fit_interval;

			var diff = this.base.show_area_wdg.offsetWidth - this.base.show_container_wdg.offsetWidth;
			var coef = diff > 0 ? 1 : -1;
			diff = Math.abs(diff);
			if (diff > this.base.ani_fit_speed) {
				diff = this.base.ani_fit_speed;
			}
			this.base.show_container_wdg.style.width = (this.base.show_container_wdg.offsetWidth + coef * diff) + "px";

			var diff = this.base.show_area_wdg.offsetHeight - this.base.show_container_wdg.offsetHeight;
			var coef = diff > 0 ? 1 : -1;
			diff = Math.abs(diff);
			if (diff > this.base.ani_fit_speed) {
				diff = this.base.ani_fit_speed;
			}
			this.base.show_container_wdg.style.height = (this.base.show_container_wdg.offsetHeight + coef * diff) + "px";
		
			this.base.deck_wdg.style.left = (this.start_x - Math.round(this.base.deck_wdg.offsetWidth / 2)) + "px";
		}
	}

	if (this.state > 1) {
		this.base.start_ani_timer(interval);
	}
}

function Mod_DMenu(params) {
	this.iname = params.iname;
	this.active_deck = "";
	this.decks = {};
	this.cards = {};
	this.ani_timer = 0;
	this.close_timer = 0;
	this.dyn_id = -1;
	this.animation = true;

	var ver = navigator.userAgent.toLowerCase().match(/msie (\d(.\d*)?)/);
	if (ver && ver[1] && ver[1] < 9) {
		this.animation = false;
	}

	var int_vars = [
		["close_timeout", 500],
		["ani_open_interval", 20],
		["ani_open_speed", 10],
		["ani_close_interval", 20],
		["ani_close_speed", 10],
		["ani_slide_interval", 20],
		["ani_slide_speed", 10],
		["ani_fit_interval", 20],
		["ani_fit_speed", 10]
	];
	for (var i = 0, len = int_vars.length; i < len; i++) {
		this[int_vars[i][0]] = typeof params[int_vars[i][0]] != "number" ? int_vars[i][1] : params[int_vars[i][0]];
		if (this[int_vars[i][0]] <= 0) {
			this[int_vars[i][0]] = int_vars[i][1];
		}
	}

	var wdgs = [
		["deck_id", "deck_wdg"],
		["show_container_id", "show_container_wdg"],
		["show_slides_id", "show_slides_wdg"],
		["show_area_id", "show_area_wdg"],
		["show_new_id", "show_new_wdg"],
		["primary_tpl_id", "primary_tpl"],
		["secondary_tpl_id", "secondary_tpl"],
		["stock_id", "stock_wdg"]
	];
	for (var i = 0, len = wdgs.length; i < len; i++) {
		var obj = document.getElementById(params[wdgs[i][0]]);
		if (obj) {
			this[wdgs[i][1]] = obj;
		}
		else {
			alert("DMenu unable to start. Missing panel " + wdgs[i][0]);
			return;
		}
	}

	if (this.ani_slide_speed <= 0 || this.ani_slide_speed > 100) {
		this.ani_slide_speed = 10;
	}

	document.getElementsByTagName("body")[0].appendChild(this.deck_wdg);
	this.deck_wdg.style.position = "absolute";
	this.deck_wdg.style.left = "0px";
	this.deck_wdg.style.top = "0px";
	this.deck_wdg.style.display = "none";
	
	this.show_container_wdg.style.overflow = "hidden";

	if (this.animation) {
		this.show_slides_wdg.style.position = "relative";
	}

	this.rsz_guide = null; // guide for resizable wrapper elements
	this.rsz_wrp = []; // resizable wrapper elements
	var node = this.deck_wdg.firstChild;
	while (node) {
		if (node.nodeType == 1) {
			if (node.className == "dmenu_dd_rsz") {
				this.rsz_guide = node;
			}
			else {
				this.rsz_wrp.push(node);
				
				if (this.animation) {
					node.style.width = "100%";
				}
			}
		}
		node = node.nextSibling;
	}	
	
	this.card_data = params.card_data;
	for (k in this.card_data) {
		if (this.card_data.hasOwnProperty(k) && this.card_data[k].hd && this.card_data[k].cnt) {
			this.add_deck_card(this.card_data[k].id);
		}
	}
}

Mod_DMenu.prototype.rsz = function (set) {
	if (!this.animation && this.rsz_guide) {
		for (var i = 0, len = this.rsz_wrp.length; i < len; i++) {
			this.rsz_wrp[i].style.width = set ? this.rsz_guide.offsetWidth + "px" : "auto";
		}
	}
}

Mod_DMenu.prototype.analyse = function (input) {
	var attr = {};
	var elements = input.split("::");
	for (var i = 0, len = elements.length; i < len; i++) {
		var m = elements[i].indexOf("=");
		if (m == -1) {
			attr[elements[i].replace(/^\s+|\s+$/g, '')] = true;
		}
		else {
			attr[elements[i].substr(0, m).replace(/^\s+|\s+$/g, '')] = elements[i].substr(m + 1).replace(/^\s+|\s+$/g, '');
		}
	}
	return attr;
}

Mod_DMenu.prototype.add_deck_card = function (id) {
	var card_id = "card_" + id;
	if (this.cards[card_id]) {
		return true;
	}
	
	var result = false;

	var hd_id = "hd_" + id;
	var hd_wdg = document.getElementById(this.iname + "_" + hd_id);
	
	var cnt_id = "cnt_" + id;
	var cnt_wdg = document.getElementById(this.iname + "_" + cnt_id);
	
	if (hd_wdg && this.card_data[card_id].link.match(/^::showmod::/)) {
		var attr = this.analyse(this.card_data[card_id].link.substr(11));
		if (attr.id) {
			var index = typeof attr.index != "undefined" ? attr.index : 1;
			var title = this.card_data[card_id] ? this.card_data[card_id].name : "";
			card_id = this.setup_module(attr.id, index, title, true, "");
			result = true;
		}
	}
	
	if (cnt_wdg && !result) {
		var rpl_src = [];
		var rpl_trg = [];

		var html = cnt_wdg.innerHTML;
		var pat = /href\s*=\s*".*?::submenu::([^"]+)"/gi;
		var match = pat.exec(html);
		while (match != null) {
			var attr = this.analyse(match[1]);
			if (attr.id) {
				rpl_src.push(match[0]);
				rpl_trg.push('href="javascript:void(0)" onclick="document.mod_dmenu_inst[\'' + this.iname + '\'].open_card(' + attr.id + ')"');
			}
			
			match = pat.exec(html);
		}

		var pat = /href\s*=\s*".*?::showmod::([^"]+)"/gi;
		var match = pat.exec(html);
		while (match != null) {
			var attr = this.analyse(match[1]);
			if (attr.id) {
				this.dyn_id++;
				var index = typeof attr.index != "undefined" ? attr.index : 1;
				rpl_src.push(match[0]);
				rpl_trg.push('href="javascript:void(0)" onclick="document.mod_dmenu_inst[\'' + this.iname + '\'].open_mod(' + this.dyn_id + ', \'\', \'' + attr.id + '\', ' + index + ')"');
			}
			
			match = pat.exec(html);
		}
		
		for (var i = 0, len = rpl_src.length; i < len; i++) {
			html = html.replace(rpl_src[i], rpl_trg[i]);
		}
		
		this.cards[card_id] = new Mod_DMenu_Card(this.iname);

		var tpl = hd_wdg ? this.primary_tpl : this.secondary_tpl;
		this.cards[card_id].wdg.innerHTML = tpl.innerHTML.replace(/{BODY}/i, '<div id="' + this.iname + "_cardcnt_" + id + '" class="dmenu_card_content"></div>');
		this.cards[card_id].wdg.innerHTML = this.cards[card_id].wdg.innerHTML.replace(/{TITLE}/i, this.card_data[card_id] ? this.card_data[card_id].name : "");
		this.cards[card_id].wdg.innerHTML = this.cards[card_id].wdg.innerHTML.replace(/class="DMENU_BACK_LINK"/i, 'class="back_link" onclick="document.mod_dmenu_inst[\'' + this.iname + '\'].back_card();"');
		this.cards[card_id].wdg.innerHTML = this.cards[card_id].wdg.innerHTML.replace(/class="DMENU_CLOSE_LINK"/i, 'class="close_link" onclick="document.mod_dmenu_inst[\'' + this.iname + '\'].start_close_timer();"');

		cnt_wdg.innerHTML = html;
		document.getElementById(this.iname + "_cardcnt_" + id).appendChild(cnt_wdg);
		this.cards[card_id].setup_wdg();

		result = true;
	}
	
	if (hd_wdg) {
		this.decks[hd_id] = new Mod_DMenu_Deck(this, hd_id, hd_wdg, this.cards[card_id] ? this.cards[card_id] : null);

		hd_wdg.setAttribute("iname", this.iname);
		hd_wdg.setAttribute("hd_id", hd_id);
		hd_wdg.onclick = function () { document.mod_dmenu_inst[this.getAttribute("iname")].h_click(this.getAttribute("hd_id")); }
		hd_wdg.onmouseover = function () { document.mod_dmenu_inst[this.getAttribute("iname")].h_mouseover(this.getAttribute("hd_id")); }
		hd_wdg.onmouseout = function () { document.mod_dmenu_inst[this.getAttribute("iname")].h_mouseout(this.getAttribute("hd_id")); }
	}
	
	return result;
}

Mod_DMenu.prototype.setup_module = function (div_id, index, title, primary, card_id) {
	// attention: card_id is a dynamic card id, not to be confused with a static card id
	
	if (typeof index != "number") {
		index = parseInt(index, 10);
	}
	index--; // transform 1-based to 0-based
	
	var node = document.getElementById(div_id);
	if (node) {
		var i = -1;
		node = node.firstChild;
		while (node) {
			if (node.nodeType == 1) {
				i++;
				if (i == index) {
					// found it
					
					// process header
					var header = node.firstChild;
					while (header && header.nodeType != 1) {
						header = header.nextSibling;
					}
					if (header && header.tagName == 'H3') {
						if (title == "") {
							title = header.innerHTML;
						}
						node.removeChild(header);
					}
					
					// insert dummy so that order is not disturbed
					var dummy = document.createElement('div');
					node.parentNode.insertBefore(dummy, node);

					break;
				}
			}

			node = node.nextSibling;
		}
	}

	if (card_id == "") {
		this.dyn_id++;
		var card_id = "dyncard_" + this.dyn_id;
	}

	this.cards[card_id] = new Mod_DMenu_Card(this.iname);

	var tpl = primary ? this.primary_tpl : this.secondary_tpl;
	this.cards[card_id].wdg.innerHTML = tpl.innerHTML.replace(/{BODY}/i, '<div id="' + this.iname + "_cardcnt_" + card_id + '" class="dmenu_card_content"></div>');
	this.cards[card_id].wdg.innerHTML = this.cards[card_id].wdg.innerHTML.replace(/{TITLE}/i, title);
	this.cards[card_id].wdg.innerHTML = this.cards[card_id].wdg.innerHTML.replace(/class="DMENU_BACK_LINK"/i, 'class="back_link" onclick="document.mod_dmenu_inst[\'' + this.iname + '\'].back_card();"');
	this.cards[card_id].wdg.innerHTML = this.cards[card_id].wdg.innerHTML.replace(/class="DMENU_CLOSE_LINK"/i, 'class="close_link" onclick="document.mod_dmenu_inst[\'' + this.iname + '\'].start_close_timer();"');

	if (!node) {
		node = document.createElement('div');
		node.appendChild(document.createTextNode("Module not found"));
	}

	document.getElementById(this.iname + "_cardcnt_" + card_id).appendChild(node);
	this.cards[card_id].setup_wdg();
	
	return card_id;
}

Mod_DMenu.prototype.h_click = function (hd_id) {
	if (this.active_deck == hd_id && this.close_timer == 0) {
		this.h_mouseout(hd_id);
	}
	else {
		this.h_mouseover(hd_id);
	}
}

Mod_DMenu.prototype.h_mouseover = function (hd_id) {
	if (this.close_timer > 0) {
		clearTimeout(this.close_timer);
		this.close_timer = 0;
	}

	if (this.active_deck == "") {
		this.active_deck = hd_id;
		this.decks[hd_id].open_main();
	}
	else if (this.active_deck == hd_id) {
		this.decks[hd_id].h_mouseover();
	}
	else {
		this.active_deck = hd_id;
		this.decks[hd_id].open_main();
	}
}

Mod_DMenu.prototype.h_mouseout = function (hd_id) {
	if (this.ani_timer == 0 && this.active_deck == hd_id) {
		this.close_timer = setTimeout('document.mod_dmenu_inst["' + this.iname + '"].start_close_timer();', this.close_timeout);
	}
}

Mod_DMenu.prototype.start_close_timer = function () {
	if (this.active_deck != "") {
		this.decks[this.active_deck].start_close_timer();
	}
}

Mod_DMenu.prototype.back_card = function () {
	if (this.active_deck != "") {
		this.decks[this.active_deck].back_card();
	}
}

Mod_DMenu.prototype.back_card = function () {
	if (this.active_deck != "") {
		this.decks[this.active_deck].back_card();
	}
}

Mod_DMenu.prototype.stop_ani_timer = function () {
	if (this.ani_timer > 0) {
		clearTimeout(this.ani_timer);
		this.ani_timer = 0;
	}
}

Mod_DMenu.prototype.start_ani_timer = function (interval) {
	this.stop_ani_timer();
	this.ani_timer = setTimeout('document.mod_dmenu_inst["' + this.iname + '"].h_ani_timer();', interval);
}

Mod_DMenu.prototype.h_ani_timer = function () {
	this.ani_timer = 0;
	if (this.active_deck != "") {
		this.decks[this.active_deck].h_ani_timer();
	}
}

Mod_DMenu.prototype.disable_deck = function (hd_id) {
	if (this.active_deck == hd_id) {
		this.active_deck = "";
	}
}

Mod_DMenu.prototype.open_card = function (id) {
	if (this.active_deck == "") {
		// exception case. should never happen
	}
	else {
		var card_id = "card_" + id;
		if (typeof this.cards[card_id] == "undefined" && !this.add_deck_card(id)) {
			alert('Card content not found');
			return;
		}
		
		this.decks[this.active_deck].open_card(this.cards[card_id]);
	}
}

Mod_DMenu.prototype.open_mod = function (dyn_id, hd_id, div_id, index) {
	if (this.active_deck == "") {
		// exception case. should never happen
	}
	else {
		var card_id = "dyncard_" + dyn_id;
		if (typeof this.cards[card_id] == "undefined") {
			this.setup_module(div_id, index, "", false, card_id);
		}

		this.decks[this.active_deck].open_card(this.cards[card_id]);
	}
}


function mod_dmenu_init() {
	if (document.mod_dmenu_data) {
		document.mod_dmenu_inst = [];
		
		for (var k in document.mod_dmenu_data) {
			if (document.mod_dmenu_data.hasOwnProperty(k)) {
				var data = document.mod_dmenu_data[k];
				document.mod_dmenu_inst[data.params.iname] = new Mod_DMenu(data.params);
			}
		}
	}
}

if (window.addEventListener) {
	window.addEventListener("load", mod_dmenu_init, false);
}
else if (window.attachEvent) {
	window.attachEvent("onload", mod_dmenu_init);
}
